﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
/*Add this line to use ExcelWriter:*/
using SoftArtisans.OfficeWriter.ExcelWriter;

namespace HelloWorld.ExcelWriter
{
    public partial class ExcelTemplate_HelloWorld : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            ErrorLabel.Visible = false;
        }

        protected void RunHelloWorld_Click(object sender, EventArgs e)
        {
            try                                    
            {
                //Instantiate the ExcelTemplate object
                ExcelTemplate XLT = new ExcelTemplate();

                //Open the template file
                XLT.Open(Page.MapPath(@"templates\Hello World.xlsx"));

                /*DataBindingProperties can be used to determine how the data 
                 * is imported. We're not going to use the properties in this 
                 * example, but it's required for binding data to the template*/
                DataBindingProperties DataProps = XLT.CreateDataBindingProperties();

                //Get the data
                string value = DataValueBox.Text.Trim();

                /*BindCellData is used to bind a variable or 1-dimensional 
                 * array to a data marker. The data marker in the template file 
                 * is %%=$DataValue */
                XLT.BindCellData(value, "DataValue", DataProps);

                //Process handles inserting the data into the file
                XLT.Process();

                /*One of the output options is to stream directly to the user 
                 * as an attachment. The'False' parameter means it should be 
                 * sent as an attachment, rather than inline*/
                XLT.Save(Page.Response, "Output.xlsx", false);

            }
            catch (Exception ex)
            {
                ErrorLabel.Visible = true;
                if (ex.Message.Contains("General license key exception"))
                {
                    ErrorLabel.Text = "OfficeWriter does not appear to be" +
                       " installed on this machine. If you have not " +
                       "purchased OfficeWriter, you can download the " +
                       "evaluation version here: " +
                       "http://www.officewriter.com/officewriter-free-evaluation.aspx";
                }
                else
                {
                    ErrorLabel.Text = ex.Message;
                }

            }

        }
    }
}
